<template>
  <Dialog title="修改参保方案" v-model="dialogVisible" width="600">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="参保方案" prop="schemeId">
        <el-select v-model="formData.schemeId" placeholder="请选择参保方案">
          <el-option
            v-for="item in insuranceSchemeOptions"
            :key="item.schemeId"
            :label="item.schemeName"
            :value="item.schemeId"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="计税规则" prop="ruleId">
        <el-select v-model="formData.ruleId" placeholder="请选择计税规则">
          <el-option
            v-for="item in salaryTaxRuleOptions"
            :key="item.ruleId"
            :label="item.ruleName"
            :value="item.ruleId"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EmployeeApi, Employee } from '@/api/hr/employee'
import { InsuranceSchemeApi, InsuranceScheme } from '@/api/hr/insurancescheme'
import { SalaryTaxRuleApi, SalaryTaxRule } from '@/api/hr/salarytaxrule'
import {DICT_TYPE, getIntDictOptions} from "@/utils/dict";

/** 员工 表单 */
defineOptions({ name: 'EmployeeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  id: undefined,
  schemeId: undefined,
  ruleId: undefined,
})
const formRules = reactive({
  schemeId: [{ required: true, message: '社保方案不能为空', trigger: 'blur' }],
})
const formRef = ref() // 表单 Ref
const insuranceSchemeOptions = ref([])
const salaryTaxRuleOptions = ref([])
/** 打开弹窗 */
const open = async (id?: number,schemeId?: number,ruleId?: number) => {
  dialogVisible.value = true
  dialogTitle.value = '修改参保方案'
  resetForm()
  formData.value.schemeId = schemeId;
  formData.value.id = id;
  formData.value.ruleId = ruleId;
  // 修改时，设置数据
  const res  = await InsuranceSchemeApi.getInsuranceSchemePage();
  insuranceSchemeOptions.value = res.list;

  const res1  = await SalaryTaxRuleApi.getSalaryTaxRulePage();
  salaryTaxRuleOptions.value = res1.list;

}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Employee
    const employeeIds = [];
    employeeIds.push(data.id);
    data.employeeIds = employeeIds;
    await EmployeeApi.updateInsuranceScheme(data)
    message.success(t('common.updateSuccess'))
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    schemeId: undefined,
    ruleId: undefined
  }
  formRef.value?.resetFields()
}
</script>
